diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 612652f03..856451543 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -8,6 +8,7 @@ import java.io.IOException;
 import java.util.ArrayList;
 import java.util.Random;
 
+import net.minecraft.client.gui.guidebook.GuiGuidebook;
 import org.lwjgl.LWJGLException;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
@@ -1069,7 +1070,17 @@ public class Minecraft
             int blockX = objectMouseOver.x;
             int blockY = objectMouseOver.y;
             int blockZ = objectMouseOver.z;
-            playerController.continueDestroyBlock(blockX, blockY, blockZ, objectMouseOver.side);
+            Side side = objectMouseOver.side;
+            double xPlaced;
+			double yPlaced = objectMouseOver.location.yCoord - objectMouseOver.y;
+			if(side.getAxis() == Axis.X) {
+				xPlaced = objectMouseOver.location.xCoord - objectMouseOver.x;
+			}else if(side.getAxis() == Axis.Z) {
+				xPlaced = objectMouseOver.location.zCoord - objectMouseOver.z;
+			}else {
+				xPlaced = objectMouseOver.location.xCoord - objectMouseOver.x;
+			}
+            playerController.continueDestroyBlock(blockX, blockY, blockZ, objectMouseOver.side, xPlaced, yPlaced);
         }
         else
         {
@@ -1111,24 +1122,18 @@ public class Minecraft
             int blockZ = objectMouseOver.z;
             Side side = objectMouseOver.side;
             double xPlaced;
-            double yPlaced = objectMouseOver.location.yCoord - objectMouseOver.y;
-
-            if (side.getAxis() == Axis.X)
-            {
-                xPlaced = objectMouseOver.location.xCoord - objectMouseOver.x;
-            }
-            else if (side.getAxis() == Axis.Z)
-            {
-                xPlaced = objectMouseOver.location.zCoord - objectMouseOver.z;
-            }
-            else
-            {
-                xPlaced = objectMouseOver.location.xCoord - objectMouseOver.x;
-            }
+			double yPlaced = objectMouseOver.location.yCoord - objectMouseOver.y;
+			if(side.getAxis() == Axis.X) {
+				xPlaced = objectMouseOver.location.xCoord - objectMouseOver.x;
+			}else if(side.getAxis() == Axis.Z) {
+				xPlaced = objectMouseOver.location.zCoord - objectMouseOver.z;
+			}else {
+				xPlaced = objectMouseOver.location.xCoord - objectMouseOver.x;
+			}
 
             if(clickType == 0)
             {
-                playerController.startDestroyBlock(blockX, blockY, blockZ, objectMouseOver.side, repeat);
+                playerController.startDestroyBlock(blockX, blockY, blockZ, objectMouseOver.side, xPlaced, yPlaced, repeat);
                 playerController.swingItem(true);
             } else
             {
@@ -1871,6 +1876,9 @@ public class Minecraft
                 gameSettings.thirdPersonView.value++;
                 gameSettings.thirdPersonView.value%=3;
             }
+            if (controllerInput.digitalPad.right.pressedThisFrame()){
+                thePlayer.displayGUIGuidebook();
+            }
         }else {
             GuiScreen currentScreen = this.currentScreen;
             if(controller.buttonB.pressedThisFrame()) {
@@ -1896,12 +1904,10 @@ public class Minecraft
             }
 
             //Inventory Controls
-            if(currentScreen instanceof GuiContainer) {
-                try{
-                    ((GuiContainer) currentScreen).controllerInput(controller);
-                }catch (Exception e) {
-                    e.printStackTrace();
-                }
+            try{
+                currentScreen.controllerInput(controller);
+            }catch (Exception e) {
+                e.printStackTrace();
             }
         }
     }
diff --git a/src/main/java/net/minecraft/client/entity/player/EntityClientPlayerMP.java b/src/main/java/net/minecraft/client/entity/player/EntityClientPlayerMP.java
index 4a7ef626d..e63d3cfb9 100644
--- a/src/main/java/net/minecraft/client/entity/player/EntityClientPlayerMP.java
+++ b/src/main/java/net/minecraft/client/entity/player/EntityClientPlayerMP.java
@@ -156,7 +156,7 @@ public class EntityClientPlayerMP extends EntityPlayerSP
 
     @Override
     public void dropCurrentItem(boolean dropFullStack) {
-        sendQueue.addToSendQueue(new Packet14BlockDig(dropFullStack ? 5 : 4, 0, 0, 0, Side.NONE));
+        sendQueue.addToSendQueue(new Packet14BlockDig(dropFullStack ? 5 : 4, 0, 0, 0, Side.NONE, 0.0, 0.0));
     }
 
     private void sendInventoryChanged()
@@ -286,7 +286,7 @@ public class EntityClientPlayerMP extends EntityPlayerSP
     
     @Override
     public void pickBlock(int x, int y, int z) {
-    	sendQueue.addToSendQueue(new Packet14BlockDig(6, x, y, z, Side.NONE));
+    	sendQueue.addToSendQueue(new Packet14BlockDig(6, x, y, z, Side.NONE, 0.0, 0.0));
     }
     public NetClientHandler sendQueue;
     private int field_9380_bx;
diff --git a/src/main/java/net/minecraft/client/gui/GuiContainer.java b/src/main/java/net/minecraft/client/gui/GuiContainer.java
index 6d63c3853..2178d5fdd 100644
--- a/src/main/java/net/minecraft/client/gui/GuiContainer.java
+++ b/src/main/java/net/minecraft/client/gui/GuiContainer.java
@@ -576,22 +576,9 @@ public abstract class GuiContainer extends GuiScreen
 //			}
 //		}
 
-		guiSpecificControllerInput(controller);
-		playControllerButtonSound(controller);
+		super.controllerInput(controller);
 	}
-	public void guiSpecificControllerInput(ControllerInput controller){
 
-	}
-
-	public void playControllerButtonSound(ControllerInput controller){
-		if(controller.buttonA.pressedThisFrame() || controller.buttonX.pressedThisFrame() || controller.buttonY.pressedThisFrame()) {
-			mc.sndManager.playSound("random.ui_click", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
-		}
-		if(controller.buttonB.pressedThisFrame()) {
-			mc.sndManager.playSound("random.ui_back", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
-		}
-	}
-	
 	private int getSlotId(int x, int y) {
 		Slot slot = getSlotAtPosition(x, y);
 		int x2 = (width - xSize) / 2;
diff --git a/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java b/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
index b79326202..0af62e9b7 100644
--- a/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
+++ b/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.gui;
 
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextureButton;
 import net.minecraft.core.Global;
+import net.minecraft.core.util.helper.Utils;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
 import org.lwjgl.input.Keyboard;
@@ -14,6 +16,7 @@ import net.minecraft.client.render.shader.PhotoModeRenderer;
 import net.minecraft.client.render.shader.Shaders;
 import net.minecraft.core.util.helper.ScreenShot;
 
+import java.io.File;
 import java.util.Locale;
 
 public class GuiPhotoMode extends GuiScreen
@@ -24,6 +27,7 @@ public class GuiPhotoMode extends GuiScreen
     private GuiSlider sliderTimeOfDay;
     private GuiButton buttonSeason;
     private GuiButton buttonTakeScreenshot;
+    private GuiListenerTextureButton buttonOpenScreenshotFolder;
     private GuiButton buttonExit;
     private GuiSlider sliderFog;
     private GuiSlider sliderTilt;
@@ -127,9 +131,11 @@ public class GuiPhotoMode extends GuiScreen
 
         buttonExit = new GuiButton(5, 0, 0, 20, 20, "X");
 
-        buttonRotateLeft = new GuiButton(0, width / 2 - 49 - 2 - 20, height - 20, 20, 20, "<");
-        buttonRotateRight = new GuiButton(1, width / 2 + 49 + 2, height - 20, 20, 20, ">");
-        buttonTakeScreenshot = new GuiButton(4, width / 2 - 49, height - 20, 98, 20, i18n.translateKey("gui.photo_mode.button.take_screenshot"));
+        buttonRotateLeft = new GuiButton(0, width / 2 - 59 - 2 - 20, height - 20, 20, 20, "<");
+        buttonRotateRight = new GuiButton(1, width / 2 + 59 + 2 + 1, height - 20, 20, 20, ">");
+        buttonTakeScreenshot = new GuiButton(4, width / 2 - 59, height - 20, 98, 20, i18n.translateKey("gui.photo_mode.button.take_screenshot"));
+        buttonOpenScreenshotFolder = new GuiListenerTextureButton(30, "/assets/minecraft/textures/gui/gui.png", buttonTakeScreenshot.getWidth() + buttonTakeScreenshot.getX() + 1, buttonTakeScreenshot.getY(), 100, 106 - 20, 20, 20);
+        buttonOpenScreenshotFolder.setActionListener(() -> Utils.openDirectory(new File(mc.getMinecraftDir(), "screenshots")));
 
         buttonCenterScreen = new GuiButton(10, width - 120, 0, 120, 20, i18n.translateKey("gui.photo_mode.button.center_camera"));
         buttonShowPlayer = new GuiButton(11, width - 120, 0, 120, 20, "");
@@ -173,6 +179,7 @@ public class GuiPhotoMode extends GuiScreen
         controlList.add(buttonRotateLeft);
         controlList.add(buttonRotateRight);
         controlList.add(buttonTakeScreenshot);
+        controlList.add(buttonOpenScreenshotFolder);
         controlList.add(buttonExit);
 
         if (desiredTOD == -1)
diff --git a/src/main/java/net/minecraft/client/gui/GuiScreen.java b/src/main/java/net/minecraft/client/gui/GuiScreen.java
index 2a8644ba0..cc38d5e21 100644
--- a/src/main/java/net/minecraft/client/gui/GuiScreen.java
+++ b/src/main/java/net/minecraft/client/gui/GuiScreen.java
@@ -5,11 +5,13 @@ import static org.lwjgl.opengl.GL11.*;
 import java.util.ArrayList;
 import java.util.List;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.util.debug.DebugRender;
 import net.minecraft.client.input.InputType;
 
+import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.sound.SoundCategory;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
@@ -203,6 +205,22 @@ public class GuiScreen extends Gui
     	drawTexturedModalRect(mc.controllerInput.cursorX - 8, mc.controllerInput.cursorY - 8, 224, 0, 16, 16, 32, 32);
     	glDisable(GL_BLEND);
     }
+    public void controllerInput(ControllerInput controller){
+        guiSpecificControllerInput(controller);
+        playControllerButtonSound(controller);
+    }
+
+    public void playControllerButtonSound(ControllerInput controller){
+        if(controller.buttonA.pressedThisFrame() || controller.buttonX.pressedThisFrame() || controller.buttonY.pressedThisFrame()) {
+            mc.sndManager.playSound("random.ui_click", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
+        }
+        if(controller.buttonB.pressedThisFrame()) {
+            mc.sndManager.playSound("random.ui_back", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
+        }
+    }
+    public void guiSpecificControllerInput(ControllerInput controller){
+
+    }
 
     public boolean pausesGame()
     {
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java b/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java
index 419149af0..e1f9157ce 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java
@@ -5,6 +5,8 @@ import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.GuiTooltip;
 import net.minecraft.client.gui.guidebook.search.SearchPage;
+import net.minecraft.client.gui.guidebook.search.SearchSection;
+import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.OpenGLHelper;
@@ -283,6 +285,62 @@ public class GuiGuidebook
             }
         }
     }
+    public void guiSpecificControllerInput(ControllerInput controller){
+        if (controller.digitalPad.left.pressedThisFrame() || (controller.digitalPad.left.isPressed() && controller.digitalPad.left.getHoldTime() % 4 == 0)){
+            pageManager.offsetPage(-2);
+            updateTabList();
+        }
+        if (controller.digitalPad.right.pressedThisFrame() || (controller.digitalPad.right.isPressed() && controller.digitalPad.right.getHoldTime() % 4 == 0)){
+            pageManager.offsetPage(2);
+            updateTabList();
+        }
+        if (controller.buttonR.pressedThisFrame()){
+            Tab t = getTab(pageManager.getCurrentSection(), true);
+            if (t != null){
+                int currentPage = pageManager.getPageIndex(pageManager.getLeftPage());
+                pageManager.setCurrentPage(pageManager.getSectionIndex(t.getSection()), true);
+                if (currentPage == pageManager.getPageIndex(pageManager.getLeftPage())){
+                    pageManager.offsetPage(2);
+                }
+                updateTabList();
+            }
+        }
+        if (controller.buttonL.pressedThisFrame()){
+            Tab t = getTab(pageManager.getCurrentSection(), false);
+            if (t != null){
+                int currentPage = pageManager.getPageIndex(pageManager.getLeftPage());
+                pageManager.setCurrentPage(pageManager.getSectionIndex(t.getSection()), true);
+                if (currentPage == pageManager.getPageIndex(pageManager.getLeftPage())){
+                    pageManager.offsetPage(-2);
+                }
+                updateTabList();
+            }
+        }
+    }
+    private Tab getTab(GuidebookSection section, boolean searchForward){
+        Tab tab = null;
+        int index = -1;
+        for (int i = 0; i < tabs.length; i++) {
+            Tab t = tabs[i];
+            if (t == null) continue;
+            if (t.getSection() == section){
+                if (section instanceof SearchSection){
+                    index = i + 1;
+                    tab = tabs[i + 1];
+                } else {
+                    index = i;
+                    tab = t;
+                }
+                break;
+            }
+        }
+        if (tab == null) return null;
+        for (int i = 1; i < tabs.length; i++) {
+            int searchDex = (tabs.length + index + (searchForward ? i : -i)) % tabs.length;
+            if (tabs[searchDex] != null) return tabs[searchDex];
+        }
+        return null;
+    }
 
     @Override
     public void tick() {
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java b/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
index aa2cec406..caf228148 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.gui.modelviewer;
 
+import com.b100.utils.FileUtils;
 import com.b100.utils.ImageUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
@@ -11,6 +12,8 @@ import net.minecraft.client.gui.modelviewer.categories.ParticleCategory;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextureButton;
+import net.minecraft.client.gui.modelviewer.elements.IActionListener;
 import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
 import net.minecraft.client.gui.options.GuiOptions;
 import net.minecraft.client.gui.options.data.OptionsPages;
@@ -26,6 +29,7 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.Buffer;
+import net.minecraft.core.util.helper.Utils;
 import net.minecraft.core.world.World;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
@@ -54,6 +58,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
     private GuiListenerButton buttonRotateRight;
     private GuiListenerButton buttonCenterScreen;
     private GuiListenerButton buttonTakeScreenshot;
+    private GuiListenerButton buttonOpenScreenshotFolder;
     private GuiListenerButton buttonExit;
     private GuiListenerSlider sliderTilt;
     private GuiListenerButton buttonShaders;
@@ -136,6 +141,8 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
 
         buttonReloadTextures = new GuiListenerButton(12, 21, height - 20, 98, 20, i18n.translateKey("gui.model_viewer.button.reload_textures"));
         buttonReloadTextures.setActionListener(() -> mc.renderEngine.refreshTexturesAndDisplayErrors());
+        buttonOpenScreenshotFolder = new GuiListenerTextureButton(30, "/assets/minecraft/textures/gui/gui.png", buttonReloadTextures.getWidth() + buttonReloadTextures.getX() + 1, buttonReloadTextures.getY(), 100, 106 - 20, 20, 20);
+        buttonOpenScreenshotFolder.setActionListener(() -> Utils.openDirectory(new File(mc.getMinecraftDir(), "")));
 
         buttonCenterScreen = new GuiListenerButton(10, 0, 0, 120, 20, i18n.translateKey("gui.photo_mode.button.center_camera"));
         buttonCenterScreen.setActionListener(() -> {
@@ -284,6 +291,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
         controlList.add(buttonRotateLeft);
         controlList.add(buttonRotateRight);
         controlList.add(buttonTakeScreenshot);
+        controlList.add(buttonOpenScreenshotFolder);
         controlList.add(buttonPrevEntry);
         controlList.add(buttonNextEntry);
         controlList.add(buttonCategory);
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextureButton.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextureButton.java
new file mode 100644
index 000000000..2f9d8d47f
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextureButton.java
@@ -0,0 +1,39 @@
+package net.minecraft.client.gui.modelviewer.elements;
+
+import net.minecraft.client.Minecraft;
+import org.lwjgl.opengl.GL11;
+
+public class GuiListenerTextureButton extends GuiListenerButton{
+    private String texturePath;
+    private int u;
+    private int v;
+    public GuiListenerTextureButton(int id, String texturePath, int xPosition, int yPosition, int u, int v, int width, int height) {
+        super(id, xPosition, yPosition, width, height, "");
+        this.texturePath = texturePath;
+        this.u = u;
+        this.v = v;
+    }
+
+    @Override
+    public void drawButton(Minecraft mc, int mouseX, int mouseY) {
+        if (!visible) {
+            return;
+        }
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture(texturePath));
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        boolean isHovered = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
+        if (!enabled)
+        {
+            drawTexturedModalRect(xPosition, yPosition, u, v, width, height);
+        }
+        else if (!isHovered)
+        {
+            drawTexturedModalRect(xPosition, yPosition, u, v + height, width, height);
+        }
+        else
+        {
+            drawTexturedModalRect(xPosition, yPosition, u, v + height * 2, width, height);
+        }
+        mouseDragged(mc, mouseX, mouseY);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/input/controller/IButton.java b/src/main/java/net/minecraft/client/input/controller/IButton.java
index 3ac3b2855..eaac271f6 100644
--- a/src/main/java/net/minecraft/client/input/controller/IButton.java
+++ b/src/main/java/net/minecraft/client/input/controller/IButton.java
@@ -11,5 +11,6 @@ public interface IButton {
 	public void update();
 	
 	public void cancelButtonPress();
+	public int getHoldTime();
 	
 }
diff --git a/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java b/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java
index 830b2423c..d81358efb 100644
--- a/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java
@@ -16,7 +16,6 @@ import net.minecraft.client.player.controller.PlayerControllerMP;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.Global;
 import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityBlastFurnace;
 import net.minecraft.core.block.entity.TileEntityDispenser;
@@ -30,31 +29,20 @@ import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.RecipeRegistry;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityBobber;
 import net.minecraft.core.entity.EntityDispatcher;
-import net.minecraft.core.entity.EntityFallingSand;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.EntityLightningBolt;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.EntityPainting;
-import net.minecraft.core.entity.EntityTNT;
 import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.entity.projectile.EntityArrow;
-import net.minecraft.core.entity.projectile.EntityArrowGolden;
-import net.minecraft.core.entity.projectile.EntityArrowPurple;
-import net.minecraft.core.entity.projectile.EntityCannonball;
-import net.minecraft.core.entity.projectile.EntityEgg;
-import net.minecraft.core.entity.projectile.EntityFireball;
-import net.minecraft.core.entity.projectile.EntityPebble;
-import net.minecraft.core.entity.projectile.EntitySnowball;
-import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.entity.vehicle.EntityMinecart;
+import net.minecraft.core.entity.projectile.EntityProjectile;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemMap;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.PlayerProfile;
+import net.minecraft.core.net.entity.NetEntityHandler;
 import net.minecraft.core.net.handler.NetHandler;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.Packet100OpenWindow;
@@ -235,134 +223,46 @@ public class NetClientHandler extends NetHandler
     @Override
     public void handlePickupSpawn(Packet21PickupSpawn packet21pickupspawn)
     {
-        double d = (double) packet21pickupspawn.xPosition / 32D;
-        double d1 = (double) packet21pickupspawn.yPosition / 32D;
-        double d2 = (double) packet21pickupspawn.zPosition / 32D;
-        EntityItem entityitem = new EntityItem(worldClient, d, d1, d2, new ItemStack(packet21pickupspawn.itemID, packet21pickupspawn.count, packet21pickupspawn.itemDamage, packet21pickupspawn.tag));
-        entityitem.xd = (double) packet21pickupspawn.rotation / 128D;
-        entityitem.yd = (double) packet21pickupspawn.pitch / 128D;
-        entityitem.zd = (double) packet21pickupspawn.roll / 128D;
+        double x = packet21pickupspawn.xPosition / 32D;
+        double y = packet21pickupspawn.yPosition / 32D;
+        double z = packet21pickupspawn.zPosition / 32D;
+        EntityItem entityitem = new EntityItem(worldClient, x, y, z, new ItemStack(packet21pickupspawn.itemID, packet21pickupspawn.count, packet21pickupspawn.itemDamage, packet21pickupspawn.tag));
+        entityitem.xd = (double) packet21pickupspawn.xd / 128D;
+        entityitem.yd = (double) packet21pickupspawn.yd / 128D;
+        entityitem.zd = (double) packet21pickupspawn.zd / 128D;
         entityitem.serverPosX = packet21pickupspawn.xPosition;
         entityitem.serverPosY = packet21pickupspawn.yPosition;
         entityitem.serverPosZ = packet21pickupspawn.zPosition;
         worldClient.addEntityToWorld(packet21pickupspawn.entityId, entityitem);
     }
 
+
     @Override
-    public void handleVehicleSpawn(Packet23VehicleSpawn packet23vehiclespawn)
-    {
-        double xPosition = (double) packet23vehiclespawn.xPosition / 32D;
-        double yPosition = (double) packet23vehiclespawn.yPosition / 32D;
-        double zPosition = (double) packet23vehiclespawn.zPosition / 32D;
-        Entity newEntity = null;
-        if (packet23vehiclespawn.type == 10)
-        {
-            newEntity = new EntityMinecart(worldClient, xPosition, yPosition, zPosition, 0);
-        }
-        if (packet23vehiclespawn.type == 11)
-        {
-            newEntity = new EntityMinecart(worldClient, xPosition, yPosition, zPosition, 1);
-        }
-        if (packet23vehiclespawn.type == 12)
-        {
-            newEntity = new EntityMinecart(worldClient, xPosition, yPosition, zPosition, 2);
-        }
-        if (packet23vehiclespawn.type == 90)
-        {
-            newEntity = new EntityBobber(worldClient, xPosition, yPosition, zPosition);
-        }
-        if (packet23vehiclespawn.type == 60)
-        {
-            if (packet23vehiclespawn.arrowType == 2)
-            {
-                newEntity = new EntityArrowGolden(worldClient, xPosition, yPosition, zPosition);
-            }
-            else if (packet23vehiclespawn.arrowType == 1)
-            {
-                newEntity = new EntityArrowPurple(worldClient, xPosition, yPosition, zPosition);
-            }
-            else
-            {
-                newEntity = new EntityArrow(worldClient, xPosition, yPosition, zPosition, packet23vehiclespawn.arrowType);
+    public void handleVehicleSpawn(Packet23VehicleSpawn packet23) {
+        if (!NetEntityHandler.hasType(packet23.type)){ return; }
+        double xPosition = ((double) packet23.xPosition) / 32D;
+        double yPosition = ((double) packet23.yPosition) / 32D;
+        double zPosition = ((double) packet23.zPosition) / 32D;
+        Entity owner;
+        if (packet23.ownerId >= 0){
+            owner = getEntityByID(packet23.ownerId);
+        } else {
+            owner = null;
+        }
+        Entity newEntity = NetEntityHandler.getTypeEntry(packet23.type).getEntity(worldClient, xPosition, yPosition, zPosition, packet23.metaData, packet23.hasVelocity, packet23.xVelocity / 8000D, packet23.yVelocity / 8000D, packet23.zVelocity / 8000D, owner);
+        if (newEntity != null) {
+            newEntity.serverPosX = packet23.xPosition;
+            newEntity.serverPosY = packet23.yPosition;
+            newEntity.serverPosZ = packet23.zPosition;
+            newEntity.yRot = packet23.yaw;
+            newEntity.xRot = packet23.pitch;
+            newEntity.id = packet23.entityId;
+            worldClient.addEntityToWorld(packet23.entityId, newEntity);
+            if (owner instanceof EntityLiving && newEntity instanceof EntityProjectile){
+                ((EntityProjectile) newEntity).owner = (EntityLiving) owner;
             }
-        }
-        if (packet23vehiclespawn.type == 61)
-        {
-            newEntity = new EntitySnowball(worldClient, xPosition, yPosition, zPosition);
-        }
-        if (packet23vehiclespawn.type == 62)
-        {
-            newEntity = new EntityEgg(worldClient, xPosition, yPosition, zPosition);
-        }
-        if (packet23vehiclespawn.type == 63)
-        {
-            newEntity = new EntityFireball(worldClient, xPosition, yPosition, zPosition, (double) packet23vehiclespawn.xVelocity / 8000D, (double) packet23vehiclespawn.yVelocity / 8000D, (double) packet23vehiclespawn.zVelocity / 8000D);
-            packet23vehiclespawn.ownerId = 0;
-        }
-        if (packet23vehiclespawn.type == 64)
-        {
-            newEntity = new EntityPebble(worldClient, xPosition, yPosition, zPosition);
-        }
-        if (packet23vehiclespawn.type == 1)
-        {
-            newEntity = new EntityBoat(worldClient, xPosition, yPosition, zPosition);
-        }
-        if (packet23vehiclespawn.type == 50)
-        {
-            newEntity = new EntityTNT(worldClient, xPosition, yPosition, zPosition);
-        }
-        if (packet23vehiclespawn.type == 70)
-        {
-            newEntity = new EntityFallingSand(worldClient, xPosition, yPosition, zPosition, Block.sand.id);
-        }
-        if (packet23vehiclespawn.type == 71)
-        {
-            newEntity = new EntityFallingSand(worldClient, xPosition, yPosition, zPosition, Block.gravel.id);
-        }
-        if (packet23vehiclespawn.type == 73)
-        {
-            newEntity = new EntityFallingSand(worldClient, xPosition, yPosition, zPosition, Block.mud.id);
-        }
-        if (packet23vehiclespawn.type == 72)
-        {
-            newEntity = new EntityCannonball(worldClient, xPosition, yPosition, zPosition);
-        }
-        if (newEntity != null)
-        {
-            newEntity.serverPosX = packet23vehiclespawn.xPosition;
-            newEntity.serverPosY = packet23vehiclespawn.yPosition;
-            newEntity.serverPosZ = packet23vehiclespawn.zPosition;
-            newEntity.yRot = packet23vehiclespawn.yaw;
-            newEntity.xRot = packet23vehiclespawn.pitch;
-            newEntity.id = packet23vehiclespawn.entityId;
-            worldClient.addEntityToWorld(packet23vehiclespawn.entityId, newEntity);
-            if (packet23vehiclespawn.ownerId > 0)
-            {
-                if (packet23vehiclespawn.type == 60)
-                {
-                    Entity entity = getEntityByID(packet23vehiclespawn.ownerId);
-                    if (entity instanceof EntityLiving)
-                    {
-                        ((EntityArrow) newEntity).owner = (EntityLiving) entity;
-                    }
-                }
-                if (packet23vehiclespawn.type == 72)
-                {
-                    Entity entity = getEntityByID(packet23vehiclespawn.ownerId);
-                    if (entity instanceof EntityLiving)
-                    {
-                        ((EntityCannonball) newEntity).owner = (EntityLiving) entity;
-                    }
-                }
-                if (packet23vehiclespawn.type == 73)
-                {
-                    Entity entity = getEntityByID(packet23vehiclespawn.ownerId);
-                    if (entity instanceof EntityLiving)
-                    {
-                        ((EntityArrowGolden) newEntity).owner = (EntityLiving) entity;
-                    }
-                }
-                newEntity.lerpMotion((double) packet23vehiclespawn.xVelocity / 8000D, (double) packet23vehiclespawn.yVelocity / 8000D, (double) packet23vehiclespawn.zVelocity / 8000D);
+            if (packet23.hasVelocity){
+                newEntity.lerpMotion(((double) packet23.xVelocity) / 8000D, ((double) packet23.yVelocity) / 8000D, ((double) packet23.zVelocity) / 8000D);
             }
         }
     }
